///////////////////////////////////////////////////
//Project 6.08 Piezo Playback
int piezo = A11;
int knock = 0;
int redLED = 9;
int SW1 = 1;
long periods[7];
long times[8];
int count = 0;
int playback = 0;

void setup(){
  pinMode(redLED,OUTPUT);
  pinMode(SW1,INPUT);
  void clearPiezo();
}

void loop(){
  knock = analogRead(piezo);
  if(knock > 40){
    times[count] = millis();
    digitalWrite(redLED,HIGH);
    delay(50);
    digitalWrite(redLED,LOW);
    count ++;
    while(knock > 20){
      clearPiezo();
      knock = analogRead(piezo);
    }
  }
  if(count==8){
    pinMode(piezo,OUTPUT);
    count = 0; //reset for next time
    //calculate period
    for(int j = 0; j<7; j++){
      periods[j] = times[j+1] - times[j];
      //make delays at least 50 milliseconds
      if(periods[j] < 51) periods[j] = 51;
    }
    //now play back until SW1 pressed
    playback = 0;
    while(digitalRead(SW1)==HIGH){    
      //create tone
      digitalWrite(redLED,HIGH);
      piezoTone(2500,50);
      digitalWrite(redLED,LOW);
      if(playback<7){
        delay(periods[playback] - 50);
      }
      else{
        delay(periods[6]);
      }      
      playback ++;
      if(playback==8) playback=0;
    } //end while for SW1
     while(digitalRead(SW1)==LOW){
      clearPiezo();
    }
  } //end if for count = 7
}

void clearPiezo(){
  pinMode(piezo,OUTPUT);
  digitalWrite(piezo,LOW);
  delay(1);
  pinMode(piezo,INPUT);
}


void piezoTone(long freq, long duration){
  long aSecond = 1000000;
  long period = aSecond/freq;
  duration = duration*1000;
  duration = duration/period;
  for(long k = 0; k < duration; k++){
    digitalWrite(piezo,HIGH);
    delayMicroseconds(period/2);
    digitalWrite(piezo,LOW);
    delayMicroseconds(period/2);
  }
}
///////////////////////////////////////////////////




